//+----------------------------------------------------------+
//|                                               EA_KING.mq4|
//|                                   Coded by Toyin Onigbogi|
//|                                  toyin_onigbogi@yahoo.com|
//|                             Idea of 2 MA cross and Pivots|
//+----------------------------------------------------------+

#property copyright "Toyin Onigbogi"
#property link      "toyin_onigbogi@yahoo.com"

extern double StopLoss = 30;                       //stoploss for an opened Order
extern double TakeProfit = 60;                     //Takeprofit for an opened order
extern double Tral_Stop = 20;                      //Trailing distance
extern int  Period_MA_1 = 4;                       //Period of EMA 1
extern int  Period_MA_2 = 8;                       //Period of EMA 2
extern int  Period_MA_3 = 9;                       //Period of LWMA
extern double Lots = 0;                            //Strictly set amount of lots
extern double Prots = 0.03;                        //Percentage of free margin
extern int Slipage = 4;                            //Slipage of security


bool Work = true;                                  //EA will work
bool New_Bar = false;                              //No new bar formed yet

string Symb;                                       //Security name

void deinit()                                      //denitialization
   {
      Comment("");                                 //No comment
   }
//+-----------------------------------------------------------------------+
//|                                                                       |
//+-----------------------------------------------------------------------+

int start()
   {
      int
      Total,                                       //Amount of orders in a Window
      Tip =-1,                                     //Type of selected order (B=0,S=1)
      d,
      Ticket;                                     //Order number
      
      double
      rates[1][6],yesterday_close,yesterday_high,yesterday_low, //Declaring previous day rates
      Rng,Pivot,Resistance_3,Resistance_2,Resistance_1,         //Today pivots
      Support_1,Support_2,Support_3,                            //Today pivots
      Lot,Lts,                                                      //Amount of lots in a selected Order
      Min_Lot,                                                  //Minimal amount of lots
      Step,                                                     //Step of lot size change
      Free,                                                     //Current free margin
      One_Lot,                                                  //Price of one lot
      Price,                                                    //Price of selected Order
      SL,                                                       //SL of a selected order
      TP,                                                       //TP of a selected order
      MA_1_t,                                                   //EMA 1
      MA_2_t,                                                   //EMA 2
      MA_3_t;                                                   //LWMA
      
      bool
      Ans =false,                                               //server response
      Opn_B =false,                                             //Criterion for opening BUY
      Opn_S =false;                                             //Criterion for opening SELL
//------------------------------------------------------------------------------------------------------
   //Preliminary Proccessing 
   if(Bars<Period_MA_3)                                         //Not enough bars
      {
      Alert("Not enough bars in the window.");
      return;                                                   //Exit Start()
      }
   if(Work==false)
      {
      Alert("Critical error. EA doesnt work.");  
      return;                                                   //Exit Start()
      }
//-----------------------------------------------------------------------------------------------------
   //Order Accounting
   Symb =Symbol();                                              //Security name
   Total =0;                                                    //Amount of Orders
   for(int i=1; i<=OrdersTotal(); i++)                          //Loop through orders
      {
         if(OrderSelect(i-1,SELECT_BY_POS)==true)               //If there is the next one
            {                                                   //Analyzing Order
               if(OrderSymbol()!=Symb)continue;                //Another security
               if(OrderType()<1)                                //Pending oder found
                  return;                                       //Exit Start()
                  
                  Total++;                                      //Counter of market order
                  if(Total>1)                                   //No more than one order
                     return;                                    //Exit Start()
                   
               Ticket =OrderTicket();                           //number of selected order
               Tip    =OrderType();                             //Type of selected Order
               Price  =OrderOpenPrice();                        //Price of selected Order
               SL     =OrderStopLoss();                         //Stoploss of selected Order
               TP     =OrderTakeProfit();                       //Takeprofit of selected Order
               Lot    =OrderLots();                             //Amount of lots
            }
          }
        
//--------------------------------------------------------------------------------------------------------
   //Fibonacci Pivots Calculation
   
   ArrayCopyRates(rates,Symb,PERIOD_D1);
    if(DayOfWeek() ==1)
      {     
         if(TimeDayOfWeek(iTime(Symb,PERIOD_D1,1)) ==5)
            {
               yesterday_close=rates[1][4];
               yesterday_high=rates[1][3];
               yesterday_low=rates[1][2];
            }
            else
               {
                  for(d=5; d>=0; d--)
                     {
                       if(TimeDayOfWeek(iTime(Symb,PERIOD_D1,d)) ==5)
                        {
                           yesterday_close=rates[d][4];
                           yesterday_high=rates[d][3];
                           yesterday_low=rates[d][2];
                          } 
                        }
                      }
                    }
                    else
                    {
                     yesterday_close =rates[1][4];
                     yesterday_high  =rates[1][3];
                     yesterday_low   =rates[1][2];
                     }
                                  
 Comment("\nYesterday Quotations:\nH ",yesterday_high,"\nL ", yesterday_low,"\nC ",yesterday_close);
     
     Rng =yesterday_high - yesterday_low;                             //Range
     Pivot =(yesterday_high+yesterday_low+yesterday_close)/3;        //Calculate pivot
     Resistance_3 =Pivot+(Rng*1.000);
     Resistance_2 =Pivot+(Rng*0.618);
     Resistance_1 =Pivot+(Rng*0.382);
     Support_1    =Pivot-(Rng*0.382);      
     Support_2    =Pivot-(Rng*0.618);           
     Support_3    =Pivot-(Rng*1.000); 
     
     Comment("\n\n\n\n\nPivot",Pivot);
     
     
//----------------------------------------------------------------------------------------------------------
   //Trading Criteria 
   MA_1_t= iMA(NULL,0,Period_MA_1,0,MODE_EMA,PRICE_CLOSE,0);           
   MA_2_t= iMA(NULL,0,Period_MA_2,0,MODE_EMA,PRICE_CLOSE,0);          
   MA_3_t= iMA(NULL,0,Period_MA_3,0,MODE_LWMA,PRICE_CLOSE,0);
   
   if(High[1]>=Resistance_1)
      Opn_B=false;
   if(Close[1]<Resistance_1 && Close[1]>Pivot && Close[1]>MA_3_t && MA_1_t>MA_2_t)
      Opn_B=true;
   if(Low[1]<Support_3 && Close[1]>Support_3 && Close[1]>MA_3_t)
      Opn_B=true;
   if(Low[1]<=Support_1)
      Opn_S=false;
   if(Close[1]>Support_1 && Close[1]<Pivot && Close[1]<MA_3_t && MA_1_t<MA_2_t)
      Opn_S=true;
   if(High[1]>Resistance_3 && Close[1]<Resistance_3 && Close[1]<MA_3_t)
      Opn_S=true;
//---------------------------------------------------------------------------------------------------------
   //Order Value
   RefreshRates();                                                          //Refresh rates
   Min_Lot  =MarketInfo(Symb,MODE_MINLOT);                                  //Minimal number of lots
   Free     =AccountFreeMargin();                                           //Free margin
   One_Lot  =MarketInfo(Symb,MODE_MARGINREQUIRED);                          //Price of 1 lot
   Step     =MarketInfo(Symb,MODE_LOTSTEP);                                 //Step is changed
   
      if(Lots>0)                                                            //If lots are set
         Lts=Lots;                                                          //Work with them
       else
         Lts=MathFloor(Free*Prots/One_Lot/Step)*Step;                        //% of free margin for opening
      if(Lts<Min_Lot)                                                       //Must not less than minimal lot
         Lts=Min_Lot;
      if(Lts*One_Lot>Free)
         {
            Alert("Not enough Money for",Lts, "Lots");
               return;                                                      //Exit Start()
          }          
   //---------------------------------------------------------------------------------------------------------
      //Opening Orders
         while(true)                                                       //Orders opening loop
            {
               Fun_New_Bar();                                              //Opening of a new bar
               if(New_Bar==false)                                          //If no new bar
                continue;                                                    //Exit Start()
               if(Total==0 && Opn_B==true)                                 //No order and open BUY is true
                  {
                     RefreshRates();
                     SL=Bid-New_Stop(StopLoss)*Point;                      //Calc. SL for open Order
                     TP=Bid+New_Stop(TakeProfit)*Point;                    //Calc. TP
                 Ticket=OrderSend(Symb,OP_BUY,Lts,Ask,Slipage,SL,TP);      //Opening BUY
                 if(Ticket<0)                                              //Success
                  return;
                  
                 }
                 if(Fun_Error(GetLastError())==1)
                  {
                     continue;
                     return;
                     }
               if(Total==0 && Opn_S==true)                                 //No order and Sell is true
                  {
                     RefreshRates();
                     SL=Ask+New_Stop(StopLoss)*Point;
                     TP=Ask-New_Stop(TakeProfit)*Point;
                 Ticket=OrderSend(Symb,OP_SELL,Lts,Bid,Slipage,SL,TP);      //Opening SELL
                 if(Ticket<0)                                              //Success
                  return;
                  
                 }
                 if(Fun_Error(GetLastError())==1)
                  {
                     continue;
                     return;
                     }
            break;
                  }
                  TrailingStops();
                  
                  
           return;
      }
      
      int Fun_Error(int Error)
         {
            switch(Error)
               {
                  case 4: Sleep(3000);
                     return(1);
                  case 130: RefreshRates(); 
                     return(1);
                  case 135: RefreshRates();
                     return(1);
                  case  136: while(RefreshRates()==false)
                     Sleep(1);
                     return(1);
                  case  137: Sleep(3000);
                     return(1);
                  case 146: Sleep(500);
                     return(1);
                  case  4066: Sleep(3000);
                     return(1);
                  //critical error
                  case 2:  Alert("common error");
                     return(0);
                  case 5:  Alert("Old terminal Version");
                     Work=false;
                     return(0);
                  case 64: Alert("Account blocked");
                     Work=false;
                     return(0);
                  case 133: Alert("Trading forbidden");
                     return(0);
                  case 134: Alert("Not enough money");
                     return(0);
                  
                }
                
             }
//--------------------------------------------------------------------------------------------------------
   //NewStop function
   int New_Stop(int Parameter)
      {
         int Min_Dist= MarketInfo(Symb,MODE_STOPLEVEL);
         if(Parameter<Min_Dist)
         {
            Parameter=Min_Dist;
            }
            return(Parameter);
            }
//-----------------------------------------------------------------------------------------------------------
   //New Bar
   void Fun_New_Bar()
      {
         static datetime New_Time=0;
         New_Bar=false;
         if(New_Time !=Time[0])
            {
            New_Time=Time[0];
            New_Bar=true;
            }
          }
//------------------------------------------------------------------------------------------------------------
   //TrailingStop
   int TrailingStops()
      {
         Symb=Symbol();
         for(int i=1; i<=OrdersTotal(); i++)
            {
               if(OrderSelect(i-1,SELECT_BY_POS)==true)
                  {
                     int Tip=OrderType();
                     if(OrderSymbol() !=Symb || Tip>1)continue;
                     double SL= OrderStopLoss();
                     while(true)
                     {
                        double TS=Tral_Stop;
                        int Min_Dist=MarketInfo(Symb,MODE_STOPLEVEL);
                        if(TS<Min_Dist)
                        TS=Min_Dist;
                        bool Modify=false;
                        switch(Tip)
                        {
                           case 0:
                           if(NormalizeDouble(SL,Digits)<NormalizeDouble(Bid-TS*Point,Digits))
                              {
                                 SL=Bid-TS*Point;
                                 Modify=true;
                                 }
                                 break;
                           case 1:
                           if(NormalizeDouble(SL,Digits)>NormalizeDouble(Ask+TS*Point,Digits)||NormalizeDouble(SL,Digits)==0)
                              {
                                 SL=Ask+TS*Point;
                                 Modify=true;
                                 }
                                }
                               if(Modify==false)
                               break;
                               
                               double TP=OrderTakeProfit();
                               double Price=OrderOpenPrice();
                               int  Ticket=OrderTicket();
                               bool Ans=OrderModify(Ticket,Price,SL,TP,0);
                               if(Ans==true)
                               break;
                               
                               if(Fun_Error(GetLastError())==1)
                                 {
                                    continue;
                                    return;
                                  }
                                }
                               }
                              }
                             return;
                            }